## ros-noetic-aruco 3.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
project(aruco)

find_package(catkin)
find_package(Eigen3 REQUIRED)
find_package(OpenCV 4.2.0 REQUIRED)
set(CMAKE_CXX_STANDARD 11) # C++11...
set(CMAKE_CXX_STANDARD_REQUIRED ON) #...is required...
set(CMAKE_CXX_EXTENSIONS ON) #...with compiler extensions like gnu++11

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES aruco
)
include_directories(
  include/aruco/)

include_directories(
  SYSTEM
  ${catkin_INCLUDE_DIRS}
  ${OpenCV_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIRS}
)

add_library(aruco
  src/aruco/cvdrawingutils.cpp
  src/aruco/cameraparameters.cpp
  src/aruco/debug.cpp
  src/aruco/dictionary.cpp
  src/aruco/ippe.cpp
  src/aruco/marker.cpp
  src/aruco/markerdetector.cpp
  src/aruco/markerlabeler.cpp
  src/aruco/markermap.cpp
  src/aruco/posetracker.cpp
  src/aruco/markerlabelers/dictionary_based.cpp
  src/aruco/markerlabelers/svmmarkers.cpp
)
target_link_libraries(aruco
  ${catkin_LIBRARIES} ${OpenCV_LIBRARIES})


#############
## Install ##
#############

install(TARGETS aruco
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)
install(DIRECTORY include/
   DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN "*.h"
)

=== debian/changelog ===
ros-noetic-aruco (3.0.1-3buster) buster; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 10 Feb 2022 00:00:00 -0000

ros-noetic-aruco (3.0.0-3buster) buster; urgency=high

  * fixes pal-robotics/aruco_ros/#89
  * Contributors: 444lhc

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 16 Jul 2021 00:00:00 -0000

ros-noetic-aruco (2.1.1-3buster) buster; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 17 Sep 2020 00:00:00 -0000

ros-noetic-aruco (2.1.0-3buster) buster; urgency=high

  * Add param to correct fisheye distortion with special CV functions
  * Add support for camera extrinsics when dealing with stereo cameras
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 21 Jan 2020 00:00:00 -0000

ros-noetic-aruco (2.0.2-3buster) buster; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 09 Nov 2019 00:00:00 -0000

ros-noetic-aruco (2.0.1-3buster) buster; urgency=high

  * Fix dependency
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Sep 2019 00:00:00 -0000

ros-noetic-aruco (1.0.0-3buster) buster; urgency=high

  * Fix shadowed variables
  * Add SYSTEN to include dirs
  * Merge pull request #68 <https://github.com/pal-robotics/aruco_ros//issues/68> from aPonza/ros_format
    Autoformatting as per CppStyleGuide
  * removed using namespace declarations
  * autoformatting as per CppStyleGuide
  * Migration to aruco 3.0.4
  * Merge branch 'indigo-devel' into kinetic-devel
  * Completely remove debug print
  * Merge pull request #37 <https://github.com/pal-robotics/aruco_ros//issues/37> from pal-robotics/remove-debug-print
    Remove debug log msg
  * Remove debug log msg
  * Merge pull request #29 <https://github.com/pal-robotics/aruco_ros//issues/29> from cehberlin/kinetic-devel
    forcing opencv3 build for kinetic
  * forcing opencv3 build for kinetic
  * Contributors: Andrea Ponza, Bence Magyar, Christopher Hrabia, Jordi Pages, Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Sep 2019 00:00:00 -0000

ros-noetic-aruco (0.2.2-3buster) buster; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 25 Jul 2017 00:00:00 -0000

ros-noetic-aruco (0.2.1-3buster) buster; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 21 Jul 2017 00:00:00 -0000

ros-noetic-aruco (0.2.0-3buster) buster; urgency=high

  * Fix compilation error in Ubuntu 16.04
    With this change, aruco_ros compiles properly in Ubuntu 16.04, ROS kinetic.
  * Contributors: Francisco

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 19 Oct 2016 00:00:00 -0000

ros-noetic-aruco (0.1.0-3buster) buster; urgency=high

  * Depend on libopencv-dev directly
  * Replace opencv2 dependency with cv_bridge
  * Update changelogs and maintainer email
  * Add aruco marker generator and opencv dependency
  * Remove duplicated images
  * Remove old launch files
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 10 Aug 2015 00:00:00 -0000

ros-noetic-aruco (0.0.1-3buster) buster; urgency=high

  * Initial release
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 20 May 2015 00:00:00 -0000

=== debian/control ===
Source: ros-noetic-aruco
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-noetic-catkin, ros-noetic-cv-bridge
Homepage: http://www.uco.es/investiga/grupos/ava/node/26
Standards-Version: 3.9.2

Package: ros-noetic-aruco
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-noetic-cv-bridge
Description: The ARUCO Library has been developed by the Ava group of the Univeristy of Cordoba(Spain).
 It provides real-time marker based 3D pose estimation using AR markers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-aruco//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-aruco 3.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,8 @@
 set(CMAKE_CXX_STANDARD 11) # C++11...
 set(CMAKE_CXX_STANDARD_REQUIRED ON) #...is required...
 set(CMAKE_CXX_EXTENSIONS ON) #...with compiler extensions like gnu++11
+string(REPLACE "-Werror=shadow" "" NEW_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
+set(CMAKE_CXX_FLAGS "${NEW_CXX_FLAGS}")
 
 catkin_package(
   INCLUDE_DIRS include
@@ -23,18 +25,23 @@
 )
 
 add_library(aruco
+  src/aruco/cameraparameters.cpp
   src/aruco/cvdrawingutils.cpp
-  src/aruco/cameraparameters.cpp
   src/aruco/debug.cpp
+  src/aruco/dictionary_based.cpp
   src/aruco/dictionary.cpp
+  src/aruco/fractaldetector.cpp
   src/aruco/ippe.cpp
   src/aruco/marker.cpp
+  src/aruco/markerdetector_impl.cpp
   src/aruco/markerdetector.cpp
   src/aruco/markerlabeler.cpp
   src/aruco/markermap.cpp
   src/aruco/posetracker.cpp
-  src/aruco/markerlabelers/dictionary_based.cpp
-  src/aruco/markerlabelers/svmmarkers.cpp
+  src/aruco/fractallabelers/fractallabeler.cpp
+  src/aruco/fractallabelers/fractalmarker.cpp
+  src/aruco/fractallabelers/fractalmarkerset.cpp
+  src/aruco/fractallabelers/fractalposetracker.cpp
 )
 target_link_libraries(aruco
   ${catkin_LIBRARIES} ${OpenCV_LIBRARIES})

=== src/aruco/CMakeLists.txt ===
set(sources
    cameraparameters.cpp
    cvdrawingutils.cpp
    dictionary.cpp
    ippe.cpp
    marker.cpp
    markerdetector.cpp
    markerlabeler.cpp
    markermap.cpp
    posetracker.cpp
    markerlabelers/dictionary_based.cpp
    debug.cpp
    markerlabelers/svmmarkers.cpp
)

set(headers
    aruco_export.h
    cameraparameters.h
    cvdrawingutils.h
    dictionary.h
    ippe.h
    marker.h
    markerdetector.h
    markerlabeler.h
    markermap.h
    posetracker.h
    markerlabelers/dictionary_based.h
    timers.h
     debug.h
     aruco.h
    markerlabelers/svmmarkers.h
)

add_library(aruco ${sources} ${headers})
IF(NOT ARUCO_ANDROID)

set_target_properties(aruco PROPERTIES          # create *nix style library versions + symbolic links
    DEFINE_SYMBOL ARUCO_DSO_EXPORTS
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_SOVERSION}
    CLEAN_DIRECT_OUTPUT 1                       # allow creating static and shared libs without conflicts
    OUTPUT_NAME "aruco${PROJECT_DLLVERSION}"    # avoid conflicts between library and binary target names
)

#include(GenerateExportHeader)
#generate_export_header(aruco)

target_link_libraries(aruco PUBLIC opencv_core)
target_link_libraries(aruco PRIVATE opencv_imgproc opencv_calib3d opencv_features2d opencv_ml)

target_include_directories(aruco PUBLIC
#  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
#  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:include>
)

install(TARGETS aruco EXPORT arucoConfig
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
    ARCHIVE DESTINATION lib
)

install(FILES ${headers}
    DESTINATION include/aruco
)

install(EXPORT arucoConfig DESTINATION "share/aruco/cmake")
ELSE()
MESSAGE(STATUS  "ARUCO COMPILATION")
target_link_libraries( # Specifies the target library.
                       aruco lib_opencv

                       # Links the target library to the log library
                       # included in the NDK.
                       ${log-lib} )

ENDIF()

=== debian/changelog ===
ros-noetic-aruco (3.1.3-1focal) focal; urgency=high

  * Fix/109/ferrum/cornerupsample
  * Contributors: josegarcia

 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Wed, 23 Nov 2022 00:00:00 -0000

ros-noetic-aruco (3.1.2-1focal) focal; urgency=high

  * disable the shadow compilation flag
  * Contributors: Sai Kishor Kothakota

 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Thu, 10 Nov 2022 00:00:00 -0000

ros-noetic-aruco (3.1.1-1focal) focal; urgency=high

  * Merge branch 'fix/remove-markerlabelers' into 'gallium-devel'
    removed markerlabelers folder
    See merge request ros-overlays/aruco_ros!6
  * removed markerlabelers folder
  * Contributors: josecarlos, saikishor

 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Tue, 08 Nov 2022 00:00:00 -0000

ros-noetic-aruco (3.1.0-1focal) focal; urgency=high

  * Merge branch 'feat/aruco-3.1.5-migration-gallium' into 'gallium-devel'
    ArUCO 3.1.5 migration gallium
    See merge request ros-overlays/aruco_ros!5
  * replace disable_pal_flags() with set DISABLE_PAL_FLAGS
  * clang formatting
  * add support for extrinsics with stereo cameras
  * Add correct fisheye distortion functionality
  * migrate to 3.1.5
  * Contributors: josecarlos, josegarcia, saikishor

 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Mon, 07 Nov 2022 00:00:00 -0000

ros-noetic-aruco (3.0.3-1focal) focal; urgency=high



 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Mon, 16 May 2022 00:00:00 -0000

ros-noetic-aruco (3.0.2-1focal) focal; urgency=high

  * Merge pull request #103 from bmagyar/make-sai-maintainer
    Make Sai maintainer of all aruco_ros packages
  * Make Sai maintainer of all
  * Update license tags in the package.xml
  * Contributors: Bence Magyar, Sai Kishor Kothakota

 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Tue, 05 Apr 2022 00:00:00 -0000

ros-noetic-aruco (3.0.1-1focal) focal; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 10 Feb 2022 00:00:00 -0000

ros-noetic-aruco (3.0.0-1focal) focal; urgency=high

  * fixes pal-robotics/aruco_ros/#89
  * Contributors: 444lhc

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 16 Jul 2021 00:00:00 -0000

ros-noetic-aruco (2.1.1-1focal) focal; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 17 Sep 2020 00:00:00 -0000

ros-noetic-aruco (2.1.0-1focal) focal; urgency=high

  * Add param to correct fisheye distortion with special CV functions
  * Add support for camera extrinsics when dealing with stereo cameras
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 21 Jan 2020 00:00:00 -0000

ros-noetic-aruco (2.0.2-1focal) focal; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 09 Nov 2019 00:00:00 -0000

ros-noetic-aruco (2.0.1-1focal) focal; urgency=high

  * Fix dependency
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Sep 2019 00:00:00 -0000

ros-noetic-aruco (1.0.0-1focal) focal; urgency=high

  * Fix shadowed variables
  * Add SYSTEN to include dirs
  * Merge pull request #68 <https://github.com/pal-robotics/aruco_ros//issues/68> from aPonza/ros_format
    Autoformatting as per CppStyleGuide
  * removed using namespace declarations
  * autoformatting as per CppStyleGuide
  * Migration to aruco 3.0.4
  * Merge branch 'indigo-devel' into kinetic-devel
  * Completely remove debug print
  * Merge pull request #37 <https://github.com/pal-robotics/aruco_ros//issues/37> from pal-robotics/remove-debug-print
    Remove debug log msg
  * Remove debug log msg
  * Merge pull request #29 <https://github.com/pal-robotics/aruco_ros//issues/29> from cehberlin/kinetic-devel
    forcing opencv3 build for kinetic
  * forcing opencv3 build for kinetic
  * Contributors: Andrea Ponza, Bence Magyar, Christopher Hrabia, Jordi Pages, Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Sep 2019 00:00:00 -0000

ros-noetic-aruco (0.2.2-1focal) focal; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 25 Jul 2017 00:00:00 -0000

ros-noetic-aruco (0.2.1-1focal) focal; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 21 Jul 2017 00:00:00 -0000

ros-noetic-aruco (0.2.0-1focal) focal; urgency=high

  * Fix compilation error in Ubuntu 16.04
    With this change, aruco_ros compiles properly in Ubuntu 16.04, ROS kinetic.
  * Contributors: Francisco

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 19 Oct 2016 00:00:00 -0000

ros-noetic-aruco (0.1.0-1focal) focal; urgency=high

  * Depend on libopencv-dev directly
  * Replace opencv2 dependency with cv_bridge
  * Update changelogs and maintainer email
  * Add aruco marker generator and opencv dependency
  * Remove duplicated images
  * Remove old launch files
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 10 Aug 2015 00:00:00 -0000

ros-noetic-aruco (0.0.1-1focal) focal; urgency=high

  * Initial release
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 20 May 2015 00:00:00 -0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: ros-noetic-aruco
 Section: misc
 Priority: optional
-Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
+Maintainer: Sai Kishor Kothakota <sai.kishor@pal-robotics.com>
 Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-noetic-catkin, ros-noetic-cv-bridge
 Homepage: http://www.uco.es/investiga/grupos/ava/node/26
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
